#include "gamec.h"

void do_cycle(GameControl* gamec) {

	animate_area(gamec);
	repaint_drawing_area(gamec);

	if(CYCLE_CNT == 0)
		g_print("cycle_cnt passed zero\n");	

	/* causes overflow after a while, 
	   so take care when dealing with a future cycle,
	   use the INCR_CYCLE(N) macro to get the cycle number N steps ahead.
	*/
	gamec->cycle_cnt++;

}

GameControl* new_gamec() {
	
	GameControl* new = (GameControl*) g_malloc(sizeof(GameControl));
	
	new->map = (Map*)new_map();
	new->map_window = (MapWin*)new_map_window();
	new->sprites = g_list_alloc();
	new->image_files = g_list_alloc();
	new->monsters = g_list_alloc();
	new->items = g_list_alloc();
	new->turn = 0;
	new->game_state = (0x0000);
	new->cycle_cnt = 1;

	return new;

}

void zap_gamec(GameControl* gamec) {

	if(gamec != NULL) {
		
		if(gamec->map != NULL) {
			
			zap_map(gamec->map);
		
		}

		if(gamec->map_window != NULL) {
			
			zap_map_window(gamec->map_window);
		
		}

		if(gamec->sprites != NULL) {
			
			g_list_foreach(gamec->sprites,(GFunc)zap_sprite,NULL);
			g_list_free(gamec->sprites);
			gamec->sprites = NULL;
		
		}
		
		if(gamec->image_files != NULL) {

			/* I don't free these strings because they're not dynamically allocated */
			g_list_free(gamec->image_files);
			gamec->image_files = NULL;

		}

		if(gamec->monsters != NULL) {

			g_list_foreach(gamec->monsters,(GFunc)zap_monster,NULL);
			g_list_free(gamec->monsters);
			gamec->monsters = NULL;
		
		}

		if(gamec->items != NULL) {

			g_list_foreach(gamec->items,(GFunc)zap_item,NULL);
			g_list_free(gamec->items);
			gamec->items = NULL;
		
		}
		
		g_free(gamec);
		gamec = NULL;

	}

}

