#include "item.h"

Item* new_item() {

	Item* new = (Item*) g_malloc(sizeof(Item));

	new->name = g_string_new("new item");
	new->x = 0;
	new->y = 0;
	new->width = 0;
	new->height = 0;
	new->state = (0x0000);	
	new->sprite_cur = 0;
	new->properties = (0x0000);
	new->kind = NEW_ITEM;
	new->weight = 0;
	new->max_hp = 1;
	new->cur_hp = 1;
	new->armor = 0;
	new->tread_dmg = 0;
	new->inbag_cnt = 0;
	new->inbag_mask = (0x0000);
	new->inbag = g_ptr_array_new();
	new->stacked = NULL;
	new->where = 0;
	new->inside = NULL;

	return new;

}

void zap_item(Item* item) {


	if(item != NULL) {

		if(item->name != NULL) {
			
			g_string_free(item->name,FALSE);
			item->name = NULL;
		
		}

		if(item->inbag != NULL) {
		
			g_ptr_array_free(item->inbag,FALSE);
			item->inbag = NULL;
		
		}

		item->stacked = NULL;
		item->inside = NULL;

		g_free(item);
		item = NULL;

	}

}

void set_item(GameControl* gamec,Item* item,guint16 kind,gchar* name) {

	gint rn = rand();
	item->kind = kind;
	item->name = g_string_assign(item->name,name);

	switch(kind) {

		case RUG:
			item->width = 1;
			item->height = 1;
			item->properties = (IS_PORTABLE | IS_MOVABLE | IS_BASHABLE | IS_STACKABLE | IS_FLAMABLE | IS_TREADABLE);
			item->weight = 40;
			item->max_hp = 2;
			item->cur_hp = 2;
			item->armor = 10;
			item->tread_dmg = 0;
			
			item->sprites[OK_1] = RUG_1;
			item->sprite_cur = OK_1;
			item->state = OK_1;
			break;
			
		case BOULDER:
			item->width = 1;
			item->height = 1;
			item->properties = (IS_PORTABLE | IS_MOVABLE | IS_BASHABLE);
			item->weight = 50000;
			item->max_hp = 250;
			item->cur_hp = 250;
			item->armor = 90;
			item->tread_dmg = 0;
			
			item->sprites[OK_1] = BOULDER_1;
			item->sprite_cur = OK_1;
			item->state = OK_1;
			break;

		case BARREL:
			item->width = 1;
			item->height = 1;
			item->properties = (IS_PORTABLE | IS_MOVABLE | IS_BASHABLE | IS_FLAMABLE);
			item->weight = 80;
			item->max_hp = 10;
			item->cur_hp = 10;
			item->armor = 60;
			item->tread_dmg = 0;
			
			item->sprites[OK_1] = BARREL_1;
			item->sprite_cur = OK_1;
			item->state = OK_1;
			break;
			
		case TREE:
			item->width = 1;
			item->height = 1;
			item->properties = (IS_BASHABLE | IS_FLAMABLE);
			item->weight = 10000;
			item->max_hp = 100;
			item->cur_hp = 100;
			item->armor = 70;
			item->tread_dmg = 0;
			
			item->sprites[OK_1] = TREE_1;
			item->sprite_cur = OK_1;
			item->state = OK_1;
			break;

		case CAMPFIRE:
			item->width = 1;
			item->height = 1;
			item->properties = (IS_BASHABLE | IS_STACKABLE | IS_FLAMABLE | IS_TREADABLE);
			item->weight = 50;
			item->max_hp = 5;
			item->cur_hp = 5;
			item->armor = 20;
			item->tread_dmg = 3;
			
			item->sprites[OK_1] = CAMPFIRE_DOUSED;
			item->sprites[ON_FIRE_1] = CAMPFIRE_BURNING_1;
			item->sprites[ON_FIRE_2] = CAMPFIRE_BURNING_2;
			item->sprites[ON_FIRE_3] = CAMPFIRE_BURNING_3;
			item->sprites[ON_FIRE_4] = CAMPFIRE_BURNING_4;
			item->sprite_cur = ((rn%4) + ON_FIRE_1);
			item->state = ((rn%4) + ON_FIRE_1);
			break;

		default:
			item->width = 1;
			item->height = 1;
			item->properties = (0x0000);
			item->weight = 0;
			item->max_hp = 1;
			item->cur_hp = 1;
			item->armor = 0;
			item->tread_dmg = 0;
			
			item->sprites[OK_1] = UNKNOWN_ITEM_ICON;
			item->sprite_cur = OK_1;
			item->state = OK_1;

	}

}

