#include "map.h"

Map* new_map() {

	Map* new = (Map*) g_malloc(sizeof(Map));
	gint i,j;

	new->name = g_string_new("new map");
	new->id = 0;

	for(j=0;j<MAX_MAP_Y;j++)
	for(i=0;i<MAX_MAP_X;i++)
		new->cell[i][j] = new_space();

	return new;

}

void zap_map(Map* map) {

	gint x,y;

	if(map != NULL) {

		if(map->name != NULL) {
		
			g_string_free(map->name,TRUE);
			map->name = NULL;
		
		}		

		for(y=0;y<MAX_MAP_Y;y++)
		for(x=0;x<MAX_MAP_X;x++)
			if(map->cell[x][y] != NULL) {

				zap_space(map->cell[x][y]);

			}

		g_free(map);
		map = NULL;

	}

}

MapWin* new_map_window() {
	
	MapWin* new = (MapWin*) g_malloc(sizeof(MapWin));

	new->window = NULL;
	new->menu = NULL;
	new->box = NULL;
	new->drawing_area = NULL;
	new->area = NULL;
	new->gc = NULL;
	new->area_cur = 0;

	new->area_ox = 0;
	new->area_oy = 0;

	new->update = g_list_alloc();

	return new;

}

void zap_map_window(MapWin* map_window) {
	
	if(map_window->update != NULL) {

		g_list_foreach(map_window->update,(GFunc)zap_coords,NULL);
		g_list_free(map_window->update);
		
	}

	if(map_window != NULL) {

		g_free(map_window);
		map_window = NULL;

	}

}

Space* new_space() {
	
	Space* new = (Space*) g_malloc(sizeof(Space));

	new->type = (0x0000);
	new->variation = 0;	
	new->sprite_cur = 0;
	new->mos = NULL;
	new->ios = NULL;

	return new;

}

void zap_space(Space* space) {
	
	if(space != NULL) {
		
		g_free(space);
		space = NULL;

	}

}

void set_space(GameControl* gamec,Space* space,guint16 type,gint variation) {

	space->type = type;
	space->variation = variation;
	
	switch(type) {

		case GRASS:	if(variation == 0) {		space->sprites[FIRST_FRAME] = GRASS_1;
								space->sprite_cur = FIRST_FRAME;
				} else if(variation == 1) {	space->sprites[FIRST_FRAME] = GRASS_2;
								space->sprite_cur = FIRST_FRAME;
				} else {			space->sprites[FIRST_FRAME] = UNKNOWN_SPACE_TYPE;
								space->sprite_cur = FIRST_FRAME;
				} break;

		case DIRT:	if(variation == 0) {		space->sprites[FIRST_FRAME] = DIRT_1;
								space->sprite_cur = FIRST_FRAME;
				} else if(variation == 1) {	space->sprites[FIRST_FRAME] = DIRT_2;
								space->sprite_cur = FIRST_FRAME;
				} else {			space->sprites[FIRST_FRAME] = UNKNOWN_SPACE_TYPE;
								space->sprite_cur = FIRST_FRAME;
				} break;

		default:	space->sprites[FIRST_FRAME] = UNKNOWN_SPACE_TYPE;
				space->sprite_cur = FIRST_FRAME;

	}

}

Coords* new_coords(gint x, gint y) {
	
	Coords* new = (Coords*) g_malloc(sizeof(Coords));

	new->x = x;
	new->y = y;

	return new;

}

void zap_coords(Coords* coords) {

	if(coords != NULL) {

		g_free(coords);
		coords = NULL;

	}

}

void add_update(GameControl* gamec,gint x,gint y) {

	g_list_append(MAP_UPDATE,new_coords(x,y));

}

void remove_update(GameControl* gamec,gint x, gint y) {
	
}

void add_map_item(GameControl* gamec,Item* item,gint x,gint y) {

	MAP(x,y)->ios = item;

}

void random_fill_map(GameControl* gamec) {

	gint x,y,rn;
	Item* item;

	srand(time(NULL));

	g_print("filling map...\n");

	for(y=0;y<MAX_MAP_Y;y++)
	for(x=0;x<MAX_MAP_X;x++) {

		set_space(gamec,MAP(x,y),GRASS,rand()%2);

		MAP(x,y)->mos = NULL;
		MAP(x,y)->ios = NULL;

		if((rn=(rand()%40))<6) {

			if(rn == 5) {

				add_map_item(gamec,item = new_item(),x,y);
				set_item(gamec,item,BOULDER,"a mossy boulder");

			} else if(rn == 4 || rn == 3) {

				add_map_item(gamec,item = new_item(),x,y);
				set_item(gamec,item,TREE,"a tree");

			} else if(rn == 2) {

				add_map_item(gamec,item = new_item(),x,y);
				set_item(gamec,item,BARREL,"a barrel");

			} else if(rn == 1) {

				add_map_item(gamec,item = new_item(),x,y);
				set_item(gamec,item,RUG,"a nice rug");

			} else if(rn == 0) {

				add_map_item(gamec,item = new_item(),x,y);
				set_item(gamec,item,CAMPFIRE,"a cozy campfire");

			}

		}

	}

}
