#include "sprite.h"

Sprite* new_sprite() {

	Sprite* new = (Sprite*) g_malloc(sizeof(Sprite));

	new->image = NULL;
	new->pixmap = NULL;
	new->mask = NULL;

	return new;

}

void zap_sprite(Sprite* sprite) {

	if(sprite != NULL) {

		if(sprite->image != NULL) {

			g_free(sprite->image);
			sprite->image = NULL;

		}

		if(sprite->pixmap != NULL) {

			g_free(sprite->pixmap);
			sprite->pixmap = NULL;
		
		}

		if(sprite->mask != NULL) {

			g_free(sprite->mask);
			sprite->mask = NULL;
		
		}

		g_free(sprite);
		sprite = NULL;

	}

}

void init_image_files(GameControl* gamec) {
	
	gamec->image_files = g_list_append(gamec->image_files,	"./images/intro_screen.jpg"	); /* INTRO_SCREEN		(1) */
	gamec->image_files = g_list_append(gamec->image_files,	"./images/logo.jpg"		); /* QUEST_LOGO		(2) */
	gamec->image_files = g_list_append(gamec->image_files,	"./images/unknown_space.xpm"	); /* UNKNOWN_SPACE_TYPE	(3) */
	gamec->image_files = g_list_append(gamec->image_files,	"./images/grass_1.xpm"		); /* GRASS_1			(4) */
	gamec->image_files = g_list_append(gamec->image_files,	"./images/grass_2.xpm"		); /* GRASS_2			(5) */
	gamec->image_files = g_list_append(gamec->image_files,	"./images/dirt_1.xpm"		); /* DIRT_1			(6) */
	gamec->image_files = g_list_append(gamec->image_files,	"./images/dirt_2.xpm"		); /* DIRT_2			(7) */
	gamec->image_files = g_list_append(gamec->image_files,	"./images/unknown_item.xpm"	); /* UNKNOWN_ITEM_ICON		(8) */
	gamec->image_files = g_list_append(gamec->image_files,	"./images/campfire_doused.xpm"	); /* CAMPFIRE_DOUSED		(9) */
	gamec->image_files = g_list_append(gamec->image_files,	"./images/campfire_1.xpm"	); /* CAMPFIRE_BURNING_1	(10) */
	gamec->image_files = g_list_append(gamec->image_files,	"./images/campfire_2.xpm"	); /* CAMPFIRE_BURNING_2	(11) */
	gamec->image_files = g_list_append(gamec->image_files,	"./images/campfire_3.xpm"	); /* CAMPFIRE_BURNING_3	(12) */
	gamec->image_files = g_list_append(gamec->image_files,	"./images/campfire_4.xpm"	); /* CAMPFIRE_BURNING_4	(13) */
	gamec->image_files = g_list_append(gamec->image_files,	"./images/rug_1.xpm"		); /* RUG_1			(14) */
	gamec->image_files = g_list_append(gamec->image_files,	"./images/boulder_1.xpm"	); /* BOULDER_1			(15) */
	gamec->image_files = g_list_append(gamec->image_files,	"./images/tree_1.xpm"		); /* TREE_1			(16) */
	gamec->image_files = g_list_append(gamec->image_files,	"./images/barrel_1.xpm"		); /* BARREL_1			(17) */

}

void init_sprites(GameControl* gamec) 
{

	init_image_files(gamec);
	g_list_foreach(gamec->image_files,(GFunc)load,gamec);

}

void load(gpointer data,GameControl* gamec) {

	if(data != NULL) {

		Sprite* sprite = new_sprite();

		sprite->image = gdk_imlib_load_image(data);
		gdk_imlib_render(sprite->image,sprite->image->rgb_width,sprite->image->rgb_height);
		sprite->pixmap = gdk_imlib_copy_image(sprite->image);
		sprite->mask = gdk_imlib_copy_mask(sprite->image);

		gamec->sprites = g_list_append(gamec->sprites,sprite);

	}

}

void make_area(GameControl* gamec,gboolean smart) {

	gint x,y;
	Coords* tmp;

	if(MAP_AREA == NULL) {

		MAP_AREA = gdk_pixmap_new(MAP_DRAWING_AREA->window,MAP_DRAWING_AREA->allocation.width,MAP_DRAWING_AREA->allocation.height,-1);

	}

	if(MAP_GC == NULL) {

		MAP_GC = gdk_gc_new(MAP_DRAWING_AREA->window);

	}

	if(smart) {

		while(g_list_length(MAP_UPDATE) > 1) {

			tmp = (Coords*) g_list_last(MAP_UPDATE)->data;

			if(tmp->y > (MAP_DRAWING_AREA->allocation.height/TILE_SIZE) ||
			   tmp->x > (MAP_DRAWING_AREA->allocation.width/TILE_SIZE)) {

				g_list_remove(MAP_UPDATE,tmp);

			} else {

				gdk_gc_set_clip_mask(MAP_GC,NULL);
				gdk_gc_set_clip_origin(MAP_GC,(((tmp->x)-AREA_OX)*TILE_SIZE),(((tmp->y)-AREA_OY)*TILE_SIZE));

				gdk_draw_pixmap(MAP_DRAWING_AREA->window,MAP_GC,
				                PIXMAP(MAP(tmp->x,tmp->y)->sprites[MAP(tmp->x,tmp->y)->sprite_cur]),
				                0,0,(((tmp->x)-AREA_OX)*TILE_SIZE),(((tmp->y)-AREA_OY)*TILE_SIZE),TILE_SIZE,TILE_SIZE);
	
				if(MAP(tmp->x,tmp->y)->ios != NULL) {
	
					gdk_gc_set_clip_mask(MAP_GC,MASK(MAP(tmp->x,tmp->y)->ios->sprites[MAP(tmp->x,tmp->y)->ios->state]));
					gdk_draw_pixmap(MAP_DRAWING_AREA->window,MAP_GC,
					                PIXMAP(MAP(tmp->x,tmp->y)->ios->sprites[MAP(tmp->x,tmp->y)->ios->sprite_cur]),
				 	                0,0,(((tmp->x)-AREA_OX)*TILE_SIZE),(((tmp->y)-AREA_OY)*TILE_SIZE),TILE_SIZE,TILE_SIZE);
	
				}
				
				g_list_remove(MAP_UPDATE,tmp);

			}

		}

	} else {

		for(y=0;y<=(MAP_DRAWING_AREA->allocation.height/TILE_SIZE);y++)
		for(x=0;x<=(MAP_DRAWING_AREA->allocation.width/TILE_SIZE);x++) {

			gdk_gc_set_clip_mask(MAP_GC,NULL);
			gdk_gc_set_clip_origin(MAP_GC,(x*TILE_SIZE),(y*TILE_SIZE));

			gdk_draw_pixmap(MAP_DRAWING_AREA->window,MAP_GC,
			                PIXMAP(MAP(AREA_OX+x,AREA_OY+y)->sprites[MAP(AREA_OX+x,AREA_OY+y)->sprite_cur]),
			                0,0,(x*TILE_SIZE),(y*TILE_SIZE),TILE_SIZE,TILE_SIZE);
	
			if(MAP(x,y)->ios != NULL) {
	
				gdk_gc_set_clip_mask(MAP_GC,MASK(MAP(AREA_OX+x,AREA_OY+y)->ios->sprites[MAP(AREA_OX+x,AREA_OY+y)->ios->state]));
				gdk_draw_pixmap(MAP_DRAWING_AREA->window,MAP_GC,
				                PIXMAP(MAP(AREA_OX+x,AREA_OY+y)->ios->sprites[MAP(AREA_OX+x,AREA_OY+y)->ios->sprite_cur]),
				                0,0,(x*TILE_SIZE),(y*TILE_SIZE),TILE_SIZE,TILE_SIZE);
	
			}
	
		}

	}

}

void animate_area(GameControl* gamec) {
	
	gint x,y,rn,tmp;

	gamec->map_window->area_cur = (gamec->map_window->area_cur == 0) ? 1 : 0;

	for(y=0;y<=(MAP_DRAWING_AREA->allocation.height/TILE_SIZE);y++)
	for(x=0;x<=(MAP_DRAWING_AREA->allocation.width/TILE_SIZE);x++) {

		if(MAP(x,y)->ios != NULL) {
			
			switch(MAP(x,y)->ios->kind) {

				case CAMPFIRE:
					rn = rand()%4;
					if(MAP(x,y)->ios->state == ON_FIRE_1 ||
					   MAP(x,y)->ios->state == ON_FIRE_2 ||
					   MAP(x,y)->ios->state == ON_FIRE_3 ||
					   MAP(x,y)->ios->state == ON_FIRE_4) {

						if((rn + ON_FIRE_1) == (MAP(x,y)->ios->state)) {
							
							if((MAP(x,y)->ios->state) == (ON_FIRE_4)) {
							
								tmp = (ON_FIRE_1);
								
							} else { 
							
								tmp = (rn + (ON_FIRE_1)) + 1;

							}
						
						} else {
					
							tmp = (rn + (ON_FIRE_1));
					
						}

						MAP(x,y)->ios->state = tmp;
						MAP(x,y)->ios->sprite_cur = tmp;

						add_update(gamec,x,y);
					} else {

					} break;

				default: break;
			
			}

		}

	}

}
